//
//  KKTableViewController.m
//  CellWithCheckbox
//
//  Created by Tasuku Maeda on 7/1/12.
//  Copyright (c) 2012 KinkumaDesign. All rights reserved.
//

#import "KKTableViewController.h"
#import "KKCellWithCheckbox.h"

@interface KKCellData:NSObject {
    NSString *_cellName;
    BOOL _isChecked;
}
@property(nonatomic, retain) NSString *cellName;
@property(nonatomic, assign) BOOL isChecked;
@end

@implementation KKCellData
@synthesize cellName = _cellName;
@synthesize isChecked = _isChecked;

- (void)dealloc
{
    [_cellName release];
    [super dealloc];
}
@end



@interface KKTableViewController ()

@end

@implementation KKTableViewController

- (id)init
{
    self = [super init];
    if (self){
        NSMutableArray *tmpArr = [[NSMutableArray alloc] init];
        for (int i = 0; i < 100; i++){
            NSString *cellName = [NSString stringWithFormat:@"row %d", i];
            KKCellData *cellData = [[KKCellData alloc] init];
            cellData.cellName = cellName;
            cellData.isChecked = NO;
            [tmpArr addObject:cellData];
            [cellData release];
        }
        _cellDataArray = [[NSArray alloc] initWithArray:tmpArr];
        [tmpArr release];
    }
    return self;
}

- (void)dealloc
{
    [_cellDataArray release];
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"KKTableViewController";
    KKCellWithCheckbox *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if(cell == nil){
        cell = [[[KKCellWithCheckbox alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:CellIdentifier] autorelease];
    }
    cell.delegate = self;
    [cell setCheckboxState:[(KKCellData *)[_cellDataArray objectAtIndex:indexPath.row] isChecked]];
    KKCellData *cellData = [_cellDataArray objectAtIndex:indexPath.row];
    [cell setCellName:cellData.cellName];

    return cell;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [_cellDataArray count];
}

- (void)cell:(KKCellWithCheckbox *)cell checkboxTappedEvent:(UITouch *)touch
{
    CGPoint touchPt = [touch locationInView:self.view];
    NSIndexPath *indexPath = [self.tableView indexPathForRowAtPoint:touchPt];
    KKCellData *cellData = [_cellDataArray objectAtIndex:indexPath.row];
    cellData.isChecked = !cellData.isChecked;
    [cell setCheckboxState:cellData.isChecked];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSLog(@"row %d is selected", indexPath.row);
}

@end
